﻿@model OperationalRiskException.Core.ViewModels.AddUserVM
@{
    ViewBag.Title = "AddUser";

}


<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="d-flex justify-content-between flex-wrap">
            <div class="d-flex align-items-end flex-wrap">
                <div class="d-flex">
                    <i class="mdi mdi-home text-muted hover-cursor"></i>
                    <p class="text-muted mb-0 hover-cursor">&nbsp;/&nbsp; User Management &nbsp;/&nbsp;</p>
                    <p class="text-primary mb-0 hover-cursor">ADD USER</p>
                </div>
            </div>

        </div>
    </div>
</div>

<div class="row">
    <div class="col-md-12 grid-margin stretch-card">
        <div class="card">
            <div class="card-body">
                <h4 class="card-title"> User Management</h4>
                <p class="card-description">
                    Create User
                </p>

                @using (Html.BeginForm("AddUser", "Account", FormMethod.Post, new { @class = "forms-sample", role = "form" }))
                {
                    @Html.AntiForgeryToken()

                    <div class="row">
                        <div class="form-group col-md-6">
                            <label for="exampleInputUsername1">Username</label>
                            <div class="row col-md-12">
                                @Html.DropDownListFor(n => n.Username, Enumerable.Empty<SelectListItem>(), "Please select a name", new { @class = "form-control select2 col-md-12", @id = "select2" })
                                @Html.ValidationMessageFor(model => model.Username, null, new { @class = "text text-danger" })
                            </div>
                        </div>

                        <div class="form-group col-md-6">
                            <label for="exampleSelectGender">User Role</label>
                            <div class="row col-md-12">
                               Operational Risk

                            </div>
                        </div>
                    </div>



                    <button type="submit" class="btn btn-primary mr-2">Add User</button>
                }
            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12 grid-margin stretch-card">
        <div class="card tablecontainer">
            <div class="card-body">
                <h4 class="card-title"></h4>
                <p class="card-description">
                    List of Users
                </p>
                <div class="table-responsive pt-3">
                    <table class="table table-bordered" id="myTable">
                        <thead class="table-dark">
							<tr>
                                <th>
                                    S/N
                                </th>
							
								<th>
									Username
								</th>
								<th>
									Department
								</th>
								<th>
									Role
								</th>
								<th>
									
								</th>
								<th>
									
								</th>

							</tr>
                        </thead>
                        <tbody>
                           

                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript">
    $(function () {
        if ('@TempData["success"]' != '') {
          toastr.success('@TempData["success"]');
        }
           if ('@TempData["error"]' != '') {
          toastr.error('@TempData["error"]');
       }
           toastr.options = {
            "closeButton": true,
            "debug": false,
            "positionClass": "toast-top-right",
            "onclick": null,
            "showDuration": "1000",
            "hideDuration": "1000",
            "timeOut": "5000",
            "extendedTimeOut": "1000",
            "showEasing": "swing",
            "hideEasing": "linear",
            "showMethod": "fadeIn",
              "hideMethod": "fadeOut"

        };
             
        var pageSize = 20;
        var optionListUrl = '@Url.Action("GetOptionList", "Account")';
        $('#select2').select2(
            {
                ajax: {
                    delay: 150,
                    url: optionListUrl,
                    dataType: 'json',
                    data: function (params) {
                        params.page = params.page || 1;
                        return {
                            searchTerm: params.term,
                            pageSize: pageSize,
                            pageNumber: params.page
                        };
                    },
                    processResults: function (data, params) {
                        params.page = params.page || 1;
                        return {
                            results: data.Results,
                            pagination: {
                                more: (params.page * pageSize) < data.Total
                            }
                        };
                    }
                },
                placeholder: "-- Please select a name --",
                minimumInputLength: 3,
                allowClear: true,
            });
    });
	  $(document).ready(function () {
	        var oTable = $("#myTable").DataTable({
            "processing": true, // for show progress bar
            "serverSide": true, // for process server side
            "filter": true, // this is for disable filter (search box)
            "orderMulti": false, // for disable multiple column at once
                columns: [

                 {'data':'S/N',  render: function (data, type, full, meta) {

                              console.log("type", type)
                              console.log("full", full)
                              console.log("meta", meta.settings._iDisplayLength)
					 
					          console.log("_iDisplayStart", meta.settings._iDisplayStart)
				
                              var result = meta.row +1 +(meta.settings._iDisplayStart);
                      
                              return result;
                               }
                  },  
   
                { 'data': 'Username'},
					{ 'data': 'Department' },
				{ 'data': 'Role' },
				  {
                    "data": "Id", orderable: false, "width": "50px", "render": function (data) {
                        return '<a class="popup" href="@Url.Action("UserUpdate","Account")/'+data+'">Edit</a>';
                    }
                },
                {
                    "data": "Id", orderable: false,"width": "50px", "render": function (data) {
                        return '<a class="popup" href="@Url.Action("DeleteUser","Account")/'+data+'">Delete</a>';
                    }
                }
            ],
           
            "delay": 150,
            "ajax": {
                "url": '@Url.Action("GetAllUsers","Account")',
                "type": "POST",
                "datatype": "json"
            }      
        })
        $('.tablecontainer').on('click', 'a.popup', function (e) {
            e.preventDefault();
            OpenPopup($(this).attr('href'));
		})

        function OpenPopup(pageUrl) {
            var $pageContent = $('<div/>');
            $pageContent.load(pageUrl, function () {
               $('#popupForm', $pageContent).removeData('validator');
               $('#popupForm', $pageContent).removeData('unobtrusiveValidation');
               $.validator.unobtrusive.parse('form');

            });

            console.log($pageContent);
			$dialog = $('<div class="popupWindow" ></div>')
				.html($pageContent)
                .dialog({
                    draggable: false,
                    autoOpen: false,
                    resizable: false,
                    model: true,
					title: ' User Management ',
					minHeight: 150,
					width:600,
					modal: true,

                    close: function () {
                        $dialog.dialog('destroy').remove();
                    }
                })

            $('.popupWindow').on('submit', '#popupForm', function (e) {
                var url = $('#popupForm')[0].action;
				$.ajax({
					type: "POST",
					url: url,
					data: $('#popupForm').serialize(),
					success: function (data) {
						if (data.status) {
                            $dialog.dialog('close');
                            this.toastr.success("Successfully Updated");
							oTable.ajax.reload();
						}
					}
				});
                e.preventDefault();
			})

			$('.popupWindow').on('reset', '#popupForm', function (e) {

				  $dialog.dialog('close');
                e.preventDefault();
			})
				//$(".ui-dialog-title").hide();

            $dialog.dialog('open');
        }
    });


</script>
